import java.awt.*;
import java.applet.*;

public class Curve extends Applet {

    static String[][] paraminfo = {
	{ "clearmenu", "String(ignored)", "If present, don't install default Ellipse/Descartes/Cassini menu items" },
	{ "settings", "String",	"initial settings, with some or all of e=N p=N slider=BOOL curve=BOOL cassini=BOOL bright={0|1|2} sep. by blanks" },
	{ "menu1",  "String",	"label for menu-item 1" },
	{ "settings1", "String", "settings string for menu-item 1" },
	{ "menu2",  "String",	"label for menu-item 2" },
	{ "settings2", "String", "settings string for menu-item 2, etc." },
	{ "etc",	"",	"and so on for as many menuN and settingsN as are supplied." },
	{ "",		"",	"Initial settings come from 'settings' if given, else first menu item" }
    };

    CurvePanel cp;


    // Note we don't have a Curve() { ... } constructor to initialize things;
    // instead, we wait for the init() method to be called.
    // That's what Applets want.

    public void init() {

	// Initially, we've got a blank panel; add a CurveDrawer subpanel.
	setLayout( new BorderLayout() );
	cp = new CurvePanel();
	add("Center", cp);

	if(getParameter("clearmenu") != null)
	    cp.clearChoices();

	for(int i = 1; getParameter("menu" + i) != null; i++) {
	    cp.addChoice( getParameter( "menu" + i ), getParameter( "settings" + i ) );
	}
	if(getParameter( "settings" ) != null) {
	    cp.applySettings( getParameter( "settings" ) );
	} else if(getParameter( "settings1" ) != null) {
	    cp.applySettings( getParameter( "settings1" ) );
	}
    }


    public void start() {
	repaint();
    }

    public void stop() {
    }

    public String getAppletInfo() {
	return "By Stuart Levy, NCSA, University of Illinois Urbana-Champaign, slevy@ncsa.uiuc.edu, Oct. 1997";
    }

    public String[][] getParameterInfo() {
	return paraminfo;
    }

    // In case we were invoked as a stand-alone program, ...
    // Note this is a "static" method -- even though we're defined inside
    // an Applet-like class, there's no actual Applet in this case.
    // Being static, we don't (can't) refer to any Applet instance variables, etc.
    public static void main( String args[] ) {

	int main_maxdepth;
	CurvePanel main_cp;

	Frame mywin = new SensitiveFrame("Curve");
	main_cp = new CurvePanel();
	mywin.add("Center", main_cp);
	mywin.resize( 500, 400 );
	mywin.show();
	for(int i = 0; i < args.length; i++)
	    main_cp.applySettings( args[i] );
    }
}

// We need to have this class just so we can catch WINDOW_DESTROY events
// reaching the frame.
class SensitiveFrame extends Frame {

    public SensitiveFrame( String s ) {
	super( s );
    }

    public SensitiveFrame() {
    }

    public boolean handleEvent( Event ev ) {
	if(ev.id == Event.WINDOW_DESTROY) {
	    System.exit(0);
	}
	return false;
    }

}
