import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class Exponbot extends Canvas
{
private Image m_imgBackBuffer;
private float m_fYValue;
private float m_fSlope;
private float m_fRatio;

  public Exponbot()
  { m_fRatio= m_fSlope= m_fYValue= 0.0f;}

  public void reshape( int iX, int iY, int iWidth, int iHeight)
  {
    m_imgBackBuffer= createImage( iWidth, iHeight);
    Clear();
    super.reshape( iX, iY, iWidth, iHeight);
  }

  public void resize( Dimension d)
  {
    m_imgBackBuffer= createImage( d.width, d.height);
    Clear();
    super.resize( d);
  }

  public void resize( int iWidth, int iHeight)
  {
    m_imgBackBuffer= createImage( iWidth, iHeight);
    Clear();
    super.resize( iWidth, iHeight);
  }

  public void Clear()
  {
    Graphics g= m_imgBackBuffer.getGraphics();
    g.setColor( getBackground());
    g.fillRect( 0, 0, m_imgBackBuffer.getWidth(null), 
                m_imgBackBuffer.getHeight(null));
    g.setColor( getForeground());

    repaint();
  }

  public void NewValues( float fY, float fS, float fR)
  {
    m_fYValue= fY;
    m_fSlope= fS;
    m_fRatio= fR;

    Graphics g;
    int iWidth= m_imgBackBuffer.getWidth( null);
    int iHeight= m_imgBackBuffer.getHeight( null);
    g= m_imgBackBuffer.getGraphics();
    g.setColor( getBackground());
    g.fillRect( 0, 0, iWidth, iHeight);
    g.setColor( getForeground());

    FontMetrics fm= g.getFontMetrics( g.getFont());
    String strTemp= "N= "+ (float)Math.round( m_fYValue* 1000.0f)/ 1000.0f;
    int iBaseLine= (iHeight- fm.getHeight())/ 2+ fm.getAscent();
    g.drawString( strTemp, iWidth/ 6- fm.stringWidth(strTemp)/ 2, iBaseLine);

    strTemp= "m= "+ (float)Math.round( m_fSlope* 1000.0f)/ 1000.0f;
    g.drawString( strTemp, iWidth/ 2- fm.stringWidth(strTemp)/ 2, iBaseLine);

    strTemp= "m/N= "+ (float)Math.round( m_fRatio* 1000.0f)/ 1000.0f;
    g.drawString( strTemp, (5* iWidth)/ 6- fm.stringWidth(strTemp)/ 2, iBaseLine);

    repaint();
  }

  public void update( Graphics g)
  {
    if( m_imgBackBuffer!= null)
      g.drawImage( m_imgBackBuffer, 0, 0, null);
  }

  public void paint( Graphics g)
  {
    if( m_imgBackBuffer!= null)
      g.drawImage( m_imgBackBuffer, 0, 0, null);
  }
}