import java.awt.*;

//
//
// SigmaCanv
//
//
public class SigmaCanv extends Canvas
{
private Image m_imgBackBuffer;
private double m_curval;

  public SigmaCanv()
  { m_curval = 1; }

  public void reshape( int iX, int iY, int iWidth, int iHeight)
  {
    m_imgBackBuffer= createImage( iWidth, iHeight);
    update();
    repaint();
    super.reshape( iX, iY, iWidth, iHeight);
  }

  public void resize( Dimension d)
  {
    m_imgBackBuffer= createImage( d.width, d.height);
    update();
    repaint();
    super.resize( d);
  }

  public void resize( int iWidth, int iHeight)
  {
    m_imgBackBuffer= createImage( iWidth, iHeight);
    update();
    repaint();
    super.resize( iWidth, iHeight);
  }

  public void update()
  {
    int iWidth= m_imgBackBuffer.getWidth(null);
    int iHeight= m_imgBackBuffer.getHeight(null);
    Graphics gBack= m_imgBackBuffer.getGraphics();

    gBack.setColor( getBackground());
    gBack.fillRect( 0, 0, iWidth, iHeight);
    gBack.setColor( getForeground());

    Font font1= gBack.getFont();

    // Choose a font size that allows at least two copies of m_curval
    // plus another 15 characters.

    FontMetrics fm0 = gBack.getFontMetrics(font1);
    int width = 2 * fm0.stringWidth( Integer.toString((int)m_curval) + "0000000000000" );
    if(width<=0) width = iWidth;
    int wantsize = (int) (font1.getSize() * iWidth / width);
    font1= new Font( "Courier", font1.getStyle(), wantsize );
    Font font2= new Font( font1.getName(), font1.getStyle(), font1.getSize()* 2+ 2);
    FontMetrics fm1= gBack.getFontMetrics( font1);
    FontMetrics fm2= gBack.getFontMetrics( font2);

    int iYfm1= (iHeight- fm1.getHeight())/ 2 + fm1.getAscent();
    int iYfm2= (iHeight- fm2.getHeight())/ 2 + fm2.getAscent();

    String str0= "(";
    int iX0= 0;

    String str1= "1+";
    int iX1= fm2.stringWidth( str0)+ 1;

    String str2= "1";
    int iY2= iYfm1- fm1.getHeight()/ 2;

    String str3= Integer.toString((int)m_curval);
    int iX3= fm1.stringWidth( str1)+ iX1+ 1;
    int iY3= iYfm1+ fm1.getHeight()/ 2;

    int iX2= (fm1.stringWidth( str3)- fm1.stringWidth( str2))/2 + iX3;

    String str4= ")";
    int iX4= fm1.stringWidth( str3)+ iX3+ 1;

    int iX5= fm2.stringWidth( str4)+ iX4+ 1;

    String str6= "=";
    int iX6= fm1.stringWidth( str3)+ iX5+ 1;

    int iX7= fm1.stringWidth( str6)+ iX6+ 1;

    float fResult= (float)Math.pow( 1.0d+ 1.0d/ m_curval, m_curval);
    fResult= (float)((double)Math.round( (double)fResult* 100000.0d)/ 100000.0d);
    String fResultStr = Float.toString( fResult );
    fResultStr = fResultStr + ("0.00000").substring(fResultStr.length());

    int iAdjust= (iWidth- (iX7+ fm1.stringWidth( "0.00000  ")));

    gBack.setFont( font1);
    gBack.drawString( str1, iX1+ iAdjust, iYfm1);
    gBack.drawString( str2, iX2+ iAdjust, iY2);
    gBack.drawString( str3, iX3+ iAdjust, iY3);
    gBack.drawLine( iX3+ iAdjust, iHeight/ 2, iX4+ iAdjust, iHeight/ 2);
    gBack.drawString( str3, iX5+ iAdjust, iY2);
    gBack.drawString( str6, iX6+ iAdjust, iYfm1);
    gBack.drawString( fResultStr, iX7+ iAdjust, iYfm1);

    gBack.setFont( font2);
    gBack.drawString( str0, iX0+ iAdjust, iYfm2);
    gBack.drawString( str4, iX4+ iAdjust, iYfm2);
    gBack.setFont( font1);
  }

  public void paint( Graphics g)
  {
    g.drawImage( m_imgBackBuffer, 0, 0, null);
  }

  public void refresh( Graphics g)
  {
    g.drawImage( m_imgBackBuffer, 0, 0, null);
  }

  public void setValue( double val ) {
    m_curval = val;
    update();
    repaint();
  }

}

