import java.awt.*;

//
//
// SigmaCanv2
//
//
public class SigmaCanv2 extends Canvas
{
private int m_iValue;
private Image m_imgBackBuffer;

  public SigmaCanv2()
  { m_iValue= 0; }

  public void reshape( int iX, int iY, int iWidth, int iHeight)
  {
    m_imgBackBuffer= createImage( iWidth, iHeight);
    update();
    repaint();
    super.reshape( iX, iY, iWidth, iHeight);
  }

  public void resize( Dimension d)
  {
    m_imgBackBuffer= createImage( d.width, d.height);
    update();
    repaint();
    super.resize( d);
  }

  public void resize( int iWidth, int iHeight)
  {
    m_imgBackBuffer= createImage( iWidth, iHeight);
    update();
    repaint();
    super.resize( iWidth, iHeight);
  }

  public void update()
  {
    int iWidth= m_imgBackBuffer.getWidth(null);
    int iHeight= m_imgBackBuffer.getHeight(null);
    Graphics gBack= m_imgBackBuffer.getGraphics();

    gBack.setColor( getBackground());
    gBack.fillRect( 0, 0, iWidth, iHeight);
    gBack.setColor( getForeground());

    Font font1= gBack.getFont();
    font1= new Font( "Courier", font1.getStyle(), font1.getSize()* 2);
    FontMetrics fm1= gBack.getFontMetrics( font1);

    int iYfm1= (iHeight- fm1.getHeight())/ 2 + fm1.getAscent();
    int iHalf= fm1.stringWidth( " ")/ 2;

    String str0= Integer.toString( m_iValue);
    int iX0= 0;
    int iY0= iYfm1- (3* fm1.getHeight())/ 2- 2;

    String str1= "k=0";
    int iX1= 0;
    int iY1= iYfm1+ (3* fm1.getHeight())/ 2+ 2;

    int iXLeft= 0;
    int iXRight= fm1.stringWidth( str1)+ iX0;
    int iXMid= (2* iXRight)/ 5;
    int iYInc= fm1.getHeight()/ 3;
    int iYBot= iHeight/ 2+ fm1.getHeight();
    int iYTop= iHeight/ 2- fm1.getHeight();

    iX0 += (fm1.stringWidth(str1) - fm1.stringWidth(str0)) / 2;

    String str2= "1";
    int iX2= iXRight+ 1+ iHalf;
    int iY2= iYfm1- fm1.getHeight()/ 2;

    String str3= "k!";
    int iX3= iXRight+ 1+ iHalf;
    int iY3= iYfm1+ fm1.getHeight()/ 2;

    String str4= "=";
    int iX4= fm1.stringWidth( str3)+ iX3+ 1+ iHalf;
    int iY4= iYfm1;

    int iX5= fm1.stringWidth( str4)+ iX4+ 1;
    int iY5= iYfm1;

    double dResult= 0.0;
    float fResult;
    for( int i= m_iValue; i> 0; i--)
    {
      dResult+= 1.0;
      dResult/= (double)i;
    }
    dResult+= 1.0f;

    fResult= (float)((double)Math.round( dResult* 100000.0)/ 100000.0);

    int iAdjust= (iWidth- (iX5+ fm1.stringWidth( "0.00000")))/ 2;

    gBack.setFont( font1);
    gBack.drawString( str0, iX0+ iAdjust, iY0);
    gBack.drawString( str1, iX1+ iAdjust, iY1);
    gBack.drawString( str2, iX2+ iAdjust, iY2);
    gBack.drawString( str3, iX3+ iAdjust, iY3);
    gBack.drawLine( iX3+ iAdjust, iHeight/ 2, iX4+ iAdjust- 1- iHalf, iHeight/ 2);
    gBack.drawString( str4, iX4+ iAdjust, iY4);
    gBack.drawString( Float.toString( fResult), iX5+ iAdjust, iY5);

    gBack.drawLine( iXLeft+ iAdjust, iYTop, iXRight+ iAdjust, iYTop);
    gBack.drawLine( iXLeft+ iAdjust, iYBot, iXRight+ iAdjust, iYBot);
    gBack.drawLine( iXLeft+ iAdjust, iYBot, iXMid+ iAdjust, iHeight/ 2);
    gBack.drawLine( iXLeft+ iAdjust, iYTop, iXMid+ iAdjust, iHeight/ 2);
    gBack.drawLine( iXRight+ iAdjust, iYTop, iXRight+ iAdjust, iYTop+ iYInc);
    gBack.drawLine( iXRight+ iAdjust, iYBot, iXRight+ iAdjust, iYBot- iYInc);
  }

  public void paint( Graphics g)
  {
    g.drawImage( m_imgBackBuffer, 0, 0, null);
  }

  public void refresh( Graphics g)
  {
    g.drawImage( m_imgBackBuffer, 0, 0, null);
  }

  public boolean handleEvent( Event e)
  {
    if( e.target== null&& e.when== -6969&& e.id== -6969&& e.x== -6969&&
        e.y== -6969&& e.modifiers== -6969&& e.arg== null)
    {
      m_iValue= e.key;
      update();
      repaint();
      return true;
    }
    else
      return super.handleEvent( e);
  }
}

