import java.awt.*;
//
//
// SliderFeedLog
//
//
public class SliderFeedLog extends Panel
{
private Scrollbar m_SB;
private TextField m_Box;
private SigmaCanv m_Target;
double m_vMin, m_vMax;
public double m_curval;

  public SliderFeedLog( SigmaCanv obj, double vMin, double vMax )
  { 
    m_Target= obj;
    m_vMin = vMin;
    m_vMax = vMax;

    GridBagLayout gl= new GridBagLayout();
    setLayout( gl);
    GridBagConstraints gb;

    /*
    gb= new GridBagConstraints();
    TextField TF= new TextField( "n:");
    TF.setEditable( false);
    gb.gridx= 0;
    gb.gridy= 0;
    gb.fill= GridBagConstraints.BOTH;
    gl.setConstraints( TF, gb);
    add( TF);
    */

    gb= new GridBagConstraints();
    String strTemp= Integer.toString( (int)vMax);
    m_Box= new TextField( strTemp, 4+ strTemp.length());
    gb.gridx= 0;
    gb.gridy= 0;
    gb.fill= GridBagConstraints.BOTH;
    gl.setConstraints( m_Box, gb);
    add( m_Box);

    gb= new GridBagConstraints();
    m_SB= new Scrollbar( Scrollbar.HORIZONTAL, 0, 1,  0, 100);
    gb.gridx= 1;
    gb.gridy= 0;
    gb.weightx= 1.0;
    gb.fill= GridBagConstraints.BOTH;
    gl.setConstraints( m_SB, gb);
    m_SB.setValue( 0 );
    m_Box.setText( Integer.toString( (int)vMin ) );
    m_curval = vMin;
    add( m_SB);
  }

  public boolean handleEvent( Event e)
  {
    if( e.target== m_SB)
    {
	int iValue= (int)m_SB.getValue();

	m_curval = Math.exp( ((double)iValue)*Math.log(m_vMax/m_vMin)/(100-1) ) * m_vMin;
	if(m_curval > m_vMax) m_curval = m_vMax;
	m_curval = Math.rint( m_curval );
	String strText= Integer.toString( (int)m_curval );
	m_Box.setText( strText );

	m_Target.setValue( m_curval );
	return true;
    }
    else if( e.target== m_Box && e.id== Event.ACTION_EVENT)
    {
	m_curval = Double.valueOf( m_Box.getText() ).doubleValue();
	m_curval = Math.rint( m_curval );
	double l = Math.log( ((m_curval <= 0) ? m_vMin : m_curval) / m_vMin ) / Math.log( m_vMax / m_vMin );
	m_SB.setValue( (int)Math.round(l * 100) );
	m_Target.setValue( m_curval );
	return true;
    }
    else
	return super.handleEvent( e);
  }
}
