import java.awt.*;
import java.awt.image.*;
import java.util.Hashtable;

public class Analyzer extends Thread
{
  private int m_aPixel[];
  private int m_iYVals[];
  private int m_iPixels;
  private int m_iPicWidth;
  private int m_iPicHeight;
  private int m_iColor1s;
  private int m_iColor2s;
  private int m_iLineX1;
  private int m_iLineX2;
  private int m_iLineY1;
  private int m_iLineY2;
  private Results m_Results;
  private Drawer m_Drawer;
  public int m_iColor1;
  public int m_iColor2;

  public Analyzer( Image Pic)
  {
    m_iColor2= m_iColor1= 0;

    m_iPicWidth= Pic.getWidth(null);
    m_iPicHeight= Pic.getHeight(null);
    m_iPixels= m_iPicWidth* m_iPicHeight;
    m_aPixel= new int[ m_iPixels];
    m_iYVals= new int[ m_iPicWidth];
    PixelGrabber pg= new PixelGrabber( Pic, 0, 0, m_iPicWidth,
                                       m_iPicHeight, m_aPixel, 0, m_iPicWidth);
    try
    {
      pg.grabPixels();
    }
    catch( Exception e)
    {
      System.err.println( e);
    }

    if( (pg.status()& ImageObserver.ABORT)!=  0)
    {
      System.err.println("image fetch aborted or errored");
    }

    int iColor3= 0;
    for( int iPixel= 0; iPixel< m_iPixels; iPixel++)
    {
      if( m_aPixel[ iPixel]!= 0xFFFFFFFF&& m_aPixel[ iPixel]!= 0xFFFFFF)
      {
        if( m_iColor1== 0)
        {
          m_iColor1= m_aPixel[ iPixel];
          m_iColor1s++;
        }
        else if( m_iColor1== m_aPixel[ iPixel])
          m_iColor1s++;
        else if( m_iColor2== 0)
        {
          m_iColor2= m_aPixel[ iPixel];
          m_iColor2s++;
        }
        else if( m_iColor2== m_aPixel[ iPixel])
          m_iColor2s++;
        else
          iColor3++;
      }
    }
    if( iColor3> 0)
      System.err.println("Warning: more than two colors and white detected");
  }

  public void AddTargets( Results ResTarget, Drawer DraTarget)
  {
    m_Drawer= DraTarget;
    m_Results= ResTarget;
  }

  public void run()
  {
    int iColor1s;
    int iColor2s;
    int iX;
    int iY;
    int iPixel;
    float fSlope;
    int aInts[];
    boolean bTop;

    while( true)
    {
      iColor1s= iColor2s= 0;
      iX= iY= 0;

      aInts= m_Drawer.GetLineCoords();
      m_iLineX1= aInts[0];
      m_iLineY1= aInts[1];
      m_iLineX2= aInts[2];
      m_iLineY2= aInts[3];
      bTop= (aInts[4]== 0? false: true);
      aInts= null;

      if( m_iLineX1== m_iLineX2)
        continue;

      fSlope= (float)(m_iLineY2- m_iLineY1)/
              (float)(m_iLineX2- m_iLineX1);

      for( iPixel= 0; iPixel< m_iPicWidth; iPixel++)
      {
        m_iYVals[ iPixel]= m_iLineY1+ (int)(fSlope* (float)iPixel);
      }

      for( iPixel= 0; iPixel< m_iPixels; iPixel++)
      {
        if( m_iColor1== m_aPixel[ iPixel])
        {
          if( iY<= m_iYVals[ iX])
            iColor1s++;
        }
        else if( m_iColor2== m_aPixel[ iPixel])
        {
          if( iY<= m_iYVals[ iX])
            iColor2s++;
        }

        iX++;
        if( iX== m_iPicWidth)
        {
          iX= 0;
          if((iY% 20)== 0)
            yield();
          iY++;
        }
      }

      if( bTop)
        m_Results.NewPercents( (float)iColor1s/ (float)m_iColor1s, (float)iColor2s/ (float)m_iColor2s);
      else
        m_Results.NewPercents( 1.0f- (float)iColor1s/ (float)m_iColor1s,
                               1.0f- (float)iColor2s/ (float)m_iColor2s);
    }
  }
}


