import java.awt.*;
import java.awt.image.*;
import java.util.Hashtable;

public class Analyzer2 extends Thread
{
  private int m_aPixel[];
  private int m_iYVals[];
  private int m_iPixels;
  private int m_iPicWidth;
  private int m_iPicHeight;
  private int m_iColor1s;
  private int m_iColor2s;
  private Input2 m_Input;
  private Drawer2 m_Drawer;
  public int m_iColor1;
  public int m_iColor2;

  public Analyzer2( Image Pic)
  {
    m_iColor2= m_iColor1= 0;

    m_iPicWidth= Pic.getWidth(null);
    m_iPicHeight= Pic.getHeight(null);
    m_iPixels= m_iPicWidth* m_iPicHeight;
    m_aPixel= new int[ m_iPixels];
    m_iYVals= new int[ (m_iPicWidth> m_iPicHeight? m_iPicWidth: m_iPicHeight)];
    PixelGrabber pg= new PixelGrabber( Pic, 0, 0, m_iPicWidth,
                                       m_iPicHeight, m_aPixel, 0, m_iPicWidth);
    try
    {
      pg.grabPixels();
    }
    catch( Exception e)
    {
      System.err.println( e);
    }

    if( (pg.status()& ImageObserver.ABORT)!=  0)
    {
      System.err.println("image fetch aborted or errored");
    }

    int iColor3= 0;
    for( int iPixel= 0; iPixel< m_iPixels; iPixel++)
    {
      if( m_aPixel[ iPixel]!= 0xFFFFFFFF&& m_aPixel[ iPixel]!= 0xFFFFFF)
      {
        if( m_iColor1== 0)
        {
          m_iColor1= m_aPixel[ iPixel];
          m_iColor1s++;
        }
        else if( m_iColor1== m_aPixel[ iPixel])
          m_iColor1s++;
        else if( m_iColor2== 0)
        {
          m_iColor2= m_aPixel[ iPixel];
          m_iColor2s++;
        }
        else if( m_iColor2== m_aPixel[ iPixel])
          m_iColor2s++;
        else
          iColor3++;
      }
    }
    if( iColor3> 0)
      System.err.println("Warning: more than two colors and white detected");
  }

  public void AddTargets( Input2 InTarget, Drawer2 DraTarget)
  {
    m_Drawer= DraTarget;
    m_Input= InTarget;
  }

  public void run()
  {
    int iColor1s;
    int iColor2s;
    boolean bStored;
    boolean bFirstColor= true;
    int iX;
    int iY, iY0;
    int iPixel;
    float fSlope;

    while( true)
    {
      iColor1s= iColor2s= 0;
      iX= iY= iY0= 0;
      bStored= false;

      fSlope= (float)Math.tan((m_Input.GetAngle()- 90.0)* 0.0174532925);

      if( fSlope< 0.0)
      {
        for( iPixel= 0; iPixel< m_iPicWidth; iPixel++)
        {
          m_iYVals[ iPixel]= (int)(fSlope* (float)iPixel)* m_iPicWidth+ iPixel;
        }

        for( iY= 1; ; iY++)
        {
          for( iX= 0; iX< m_iPicWidth; iX++)
          {
            if( m_iYVals[ iX]< 0)
            {
              while( iX< m_iPicWidth)
              {
                m_iYVals[ iX]+= m_iPicWidth;
                iX++;
              }
            }
            else if( m_iYVals[ iX]< m_iPixels)
            {
              if( m_iColor1== m_aPixel[ m_iYVals[ iX]])
                iColor1s++;
              else if( m_iColor2== m_aPixel[ m_iYVals[ iX]])
                iColor2s++;
              m_iYVals[ iX]+= m_iPicWidth;
            }
          }

          if( (iX% 20)== 0)
            yield();
          if( iColor1s> (m_iColor1s/ 2))
          {
            if( !bStored)
            {
              iY0= iY;
              bStored= true;
              bFirstColor= true;
            };

            if( iColor2s> (m_iColor2s/ 2))
              break;
          }
          else if( iColor2s> (m_iColor2s/ 2))
          {
            if( !bStored)
            {
              iY0= iY;
              bStored= true;
              bFirstColor= false;
            }
          
            if( iColor1s> (m_iColor1s/ 2))
              break;
          }
        }

        if( bFirstColor)
          m_Drawer.NewLines( 0, iY0, 0, iY, fSlope);
        else
          m_Drawer.NewLines( 0, iY, 0, iY0, fSlope);
      }
      else
      {
        for( iPixel= 0; iPixel< m_iPicWidth; iPixel++)
        {
          m_iYVals[ iPixel]= (int)(-fSlope* (float)(m_iPicWidth- iPixel))* m_iPicWidth+ iPixel;
        }

        for( iY= 1; ; iY++)
        {
          for( iX= m_iPicWidth- 1; iX>= 0; iX--)
          {
            if( m_iYVals[ iX]< 0)
            {
              while( iX>= 0)
              {
                m_iYVals[ iX]+= m_iPicWidth;
                iX--;
              }
            }
            else if( m_iYVals[ iX]< m_iPixels)
            {
              if( m_iColor1== m_aPixel[ m_iYVals[ iX]])
                iColor1s++;
              else if( m_iColor2== m_aPixel[ m_iYVals[ iX]])
                iColor2s++;
              m_iYVals[ iX]+= m_iPicWidth;
            }
          }

          if( (iX% 20)== 0)
            yield();
          if( iColor1s> (m_iColor1s/ 2))
          {
            if( !bStored)
            {
              iY0= iY;
              bStored= true;
              bFirstColor= true;
            };

            if( iColor2s> (m_iColor2s/ 2))
              break;
          }
          else if( iColor2s> (m_iColor2s/ 2))
          {
            if( !bStored)
            {
              iY0= iY;
              bStored= true;
              bFirstColor= false;
            }
          
            if( iColor1s> (m_iColor1s/ 2))
              break;
          }
        }

        if( bFirstColor)
          m_Drawer.NewLines( m_iPicWidth- 1, iY0, m_iPicWidth- 1, iY, fSlope);
        else
          m_Drawer.NewLines( m_iPicWidth- 1, iY, m_iPicWidth- 1, iY0, fSlope);
      }
    }
  }
}


