import java.applet.*;
import java.net.URL;
import java.awt.*;
import java.awt.image.*;

class Results extends Canvas
{
  private Image m_BackBuffer;
  private Image m_StaticControl;
  private int m_iColor1;
  private int m_iColor2;
  private int m_iColor1YOffset;
  private int m_iColor2YOffset;
  private int m_iColorHeight;
  private int m_iColorXOffset;
  private int m_iColorWidth;
  private Font m_Font;
  private boolean m_bDrawn;

  public Results( int iColor1, int iColor2)
  {
    super();
    m_iColor1= iColor1;
    m_iColor2= iColor2;
  }

  public synchronized void NewPercents( float fPer1, float fPer2)
  {
    Graphics g= m_BackBuffer.getGraphics();
    Dimension Dim= size();
    g.setColor( getForeground());
    g.setFont( m_Font);
    g.drawImage( m_StaticControl, 0, 0, null);

    FontMetrics fm= g.getFontMetrics( m_Font);
    int Offset= m_iColorXOffset- 1+ (int)((float)m_iColorWidth* fPer1);
    g.fillRect( Offset, m_iColor1YOffset- 1, 3, m_iColorHeight+ 2);

    String strPercent= Integer.toString((int)(fPer1* 100.0f))+ "%";
    g.drawString( strPercent, Dim.width- m_iColorXOffset- fm.stringWidth( strPercent),
                  m_iColor1YOffset+ fm.getAscent()/ 2+ m_iColorHeight/ 2);

    Offset= m_iColorXOffset- 1+ (int)((float)m_iColorWidth* fPer2);
    g.fillRect( Offset, m_iColor2YOffset- 1, 3, m_iColorHeight+ 2);

    strPercent= Integer.toString((int)(fPer2* 100.0f))+ "%";
    g.drawString( strPercent, Dim.width- m_iColorXOffset- fm.stringWidth( strPercent),
                  m_iColor2YOffset+ fm.getAscent()/ 2+ m_iColorHeight/ 2);
    repaint();

    m_bDrawn= false;
    while( !m_bDrawn)
    {
      try
      {
        wait();
      } catch( Exception e) {}
    }
  }

  public synchronized void refresh( Graphics g)
  {
    if( m_BackBuffer!= null)
      g.drawImage( m_BackBuffer, 0, 0, null);
    m_bDrawn= true;
    notify();
  }

  public synchronized void paint( Graphics g)
  {
    if( m_BackBuffer!= null)
      g.drawImage( m_BackBuffer, 0, 0, null);
    else
    {
      Dimension Dim= size();
      FontMetrics fm= g.getFontMetrics( g.getFont());

      m_Font= g.getFont();
      m_BackBuffer= createImage( Dim.width, Dim.height);
      m_StaticControl= createImage( Dim.width, Dim.height);

      Graphics StaticG= m_StaticControl.getGraphics();
      StaticG.setColor( getForeground());
      StaticG.fillRect( 0, 0, Dim.width, Dim.height);
      StaticG.setColor( getBackground());
      StaticG.fillRect( 1, 1, Dim.width- 2, Dim.height- 2);

      m_iColorXOffset= Dim.width/ 20;
      m_iColorWidth= Dim.width- (3* Dim.width/ 20)- fm.stringWidth("100%");
      m_iColor1YOffset= Dim.height/ 6;
      m_iColorHeight= m_iColor1YOffset;

      int iHalf= m_iColorXOffset+ m_iColorWidth/ 2;
      StaticG.setColor( getForeground());
      StaticG.drawLine( iHalf, Dim.height/ 12, iHalf, 5* Dim.height/ 12);
      StaticG.drawLine( iHalf, 7* Dim.height/ 12, iHalf, 11* Dim.height/ 12);

      StaticG.setColor( new Color( m_iColor1));
      StaticG.fillRect( m_iColorXOffset, m_iColor1YOffset, m_iColorWidth, m_iColorHeight);

      StaticG.setColor( new Color( m_iColor2));
      m_iColor2YOffset= 2* Dim.height/ 3;
      StaticG.fillRect( m_iColorXOffset, m_iColor2YOffset, m_iColorWidth, m_iColorHeight);

      StaticG.setColor( getForeground());
      m_BackBuffer.getGraphics().drawImage( m_StaticControl, 0, 0, null);
      repaint();
    }
    m_bDrawn= true;
    notify();
 }
}